package vm

import (
	"context"
	"github.com/jinzhu/copier"
	"github.com/pkg/errors"
	"gitlink.org.cn/JointCloud/pcm-coordinator/pkg/helper/xerr"
	"gitlink.org.cn/JointCloud/pcm-coordinator/pkg/repository/result"
	"gitlink.org.cn/JointCloud/pcm-coordinator/pkg/utils"
	"gitlink.org.cn/JointCloud/pcm-openstack/openstack"
	"k8s.io/apimachinery/pkg/util/json"

	"gitlink.org.cn/JointCloud/pcm-coordinator/internal/svc"
	"gitlink.org.cn/JointCloud/pcm-coordinator/internal/types"

	"github.com/zeromicro/go-zero/core/logx"
)

type ShowFirewallPolicyDetailsLogic struct {
	logx.Logger
	ctx    context.Context
	svcCtx *svc.ServiceContext
}

func NewShowFirewallPolicyDetailsLogic(ctx context.Context, svcCtx *svc.ServiceContext) *ShowFirewallPolicyDetailsLogic {
	return &ShowFirewallPolicyDetailsLogic{
		Logger: logx.WithContext(ctx),
		ctx:    ctx,
		svcCtx: svcCtx,
	}
}

func (l *ShowFirewallPolicyDetailsLogic) ShowFirewallPolicyDetails(req *types.ShowFirewallPolicyDetailsReq) (resp *types.ShowFirewallPolicyDetailsResp, err error) {
	// todo: add your logic here and delete this line
	ShowFirewallPolicyDetailsReq := &openstack.ShowFirewallPolicyDetailsReq{}
	err = copier.CopyWithOption(ShowFirewallPolicyDetailsReq, req, copier.Option{Converters: utils.Converters})
	ShowFirewallPolicyDetailsResp, err := l.svcCtx.OpenstackRpc.ShowFirewallPolicyDetails(l.ctx, ShowFirewallPolicyDetailsReq)
	if err != nil {
		return nil, errors.Wrapf(xerr.NewErrMsg("c端创建失败"), "c端创建失败 : %v ,req:%+v", err, req)
	}
	marshal, err := json.Marshal(&ShowFirewallPolicyDetailsResp)
	if err != nil {
		return nil, result.NewDefaultError(err.Error())
	}
	json.Unmarshal(marshal, &resp)
	err = copier.CopyWithOption(&resp, &ShowFirewallPolicyDetailsResp, copier.Option{Converters: utils.Converters})
	return resp, err
}
